diff --git a/pgadmin/ctl/ctlComboBox.cpp b/pgadmin/ctl/ctlComboBox.cpp
index bebf242..88fcdbd 100644
--- a/pgadmin/ctl/ctlComboBox.cpp
+++ b/pgadmin/ctl/ctlComboBox.cpp
@@ -96,21 +96,21 @@ long ctlComboBoxFix::GetLongKey(int sel)
 {
 	if (sel < 0)
 		sel = GetSelection();
-	return (long)GetClientData(sel);
+	return (long)wxItemContainer::GetClientData(sel);
 }
 
 OID ctlComboBoxFix::GetOIDKey(int sel)
 {
 	if (sel < 0)
 		sel = GetSelection();
-	return (OID)GetClientData(sel);
+	return (OID)wxItemContainer::GetClientData(sel);
 }
 
 wxString ctlComboBoxFix::GetStringKey(int sel)
 {
 	if (sel < 0)
 		sel = GetSelection();
-	StringClientData *scd = (StringClientData *)GetClientObject(sel);
+	StringClientData *scd = (StringClientData *)wxItemContainer::GetClientObject(sel);
 	if (scd)
 		return scd->str;
 	return wxEmptyString;
diff --git a/pgadmin/dd/ddmodel/ddTextEditor.cpp b/pgadmin/dd/ddmodel/ddTextEditor.cpp
index 8dcc6a5..1196f31 100644
--- a/pgadmin/dd/ddmodel/ddTextEditor.cpp
+++ b/pgadmin/dd/ddmodel/ddTextEditor.cpp
@@ -41,7 +41,7 @@ ddTextEditor::ddTextEditor(wxString initialText) : wxFrame(NULL, wxID_ANY, wxT("
 void ddTextEditor::OnSave(wxCommandEvent &event)
 {
 	wxFileDialog *saveDialog = new wxFileDialog(this, wxT("Save File~"), wxT(""), wxT(""),
-	        wxT("Text Files (*.txt)|*.txt|C++ Files (*.cpp)|*.cpp"), wxSAVE);
+	        wxT("Text Files (*.txt)|*.txt|C++ Files (*.cpp)|*.cpp"), wxFD_SAVE);
 	int response = saveDialog->ShowModal();
 	if (response == wxID_OK)
 	{
@@ -52,7 +52,7 @@ void ddTextEditor::OnSave(wxCommandEvent &event)
 void ddTextEditor::OnOpen(wxCommandEvent &event)
 {
 	wxFileDialog *openDialog = new wxFileDialog(this, wxT("Open File~"), wxT(""), wxT(""),
-	        wxT("Text Files (*.txt)|*.txt|C++ Files (*.cpp)|*.cpp"), wxOPEN);
+	        wxT("Text Files (*.txt)|*.txt|C++ Files (*.cpp)|*.cpp"), wxFD_OPEN);
 	int response = openDialog->ShowModal();
 	if (response == wxID_OK)
 	{
diff --git a/pgadmin/dlg/dlgDatabase.cpp b/pgadmin/dlg/dlgDatabase.cpp
index 195ea55..07a3652 100644
--- a/pgadmin/dlg/dlgDatabase.cpp
+++ b/pgadmin/dlg/dlgDatabase.cpp
@@ -422,7 +422,7 @@ bool dlgDatabase::executeDDLSql(const wxString &strSql)
 		wxString tmp;
 		if (cbClusterSet && cbClusterSet->GetSelection() > 0)
 		{
-			replClientData *data = (replClientData *)cbClusterSet->GetClientData(cbClusterSet->GetSelection());
+			replClientData *data = (replClientData *)cbClusterSet->wxItemContainer::GetClientData(cbClusterSet->GetSelection());
 
 			if (data->majorVer > 1 || (data->majorVer == 1 && data->minorVer >= 2))
 			{
diff --git a/pgadmin/dlg/dlgProperty.cpp b/pgadmin/dlg/dlgProperty.cpp
index 4ac1a18..244295d 100644
--- a/pgadmin/dlg/dlgProperty.cpp
+++ b/pgadmin/dlg/dlgProperty.cpp
@@ -700,7 +700,7 @@ void dlgProperty::FillSQLTextfield()
 		wxString tmp;
 		if (cbClusterSet && cbClusterSet->GetSelection() > 0)
 		{
-			replClientData *data = (replClientData *)cbClusterSet->GetClientData(cbClusterSet->GetSelection());
+			replClientData *data = (replClientData *)cbClusterSet->wxItemContainer::GetClientData(cbClusterSet->GetSelection());
 			tmp.Printf(_("-- Execute replicated using cluster \"%s\", set %ld\n"), data->cluster.c_str(), data->setId);
 		}
 		sqlTextField1->SetText(tmp + GetSql());
@@ -952,7 +952,7 @@ wxString dlgProperty::BuildSql(const wxString &sql)
 
 	if (cbClusterSet && cbClusterSet->GetSelection() > 0)
 	{
-		replClientData *data = (replClientData *)cbClusterSet->GetClientData(cbClusterSet->GetSelection());
+		replClientData *data = (replClientData *)cbClusterSet->wxItemContainer::GetClientData(cbClusterSet->GetSelection());
 
 		if (data->majorVer > 1 || (data->majorVer == 1 && data->minorVer >= 2))
 		{
diff --git a/pgadmin/dlg/dlgSelectConnection.cpp b/pgadmin/dlg/dlgSelectConnection.cpp
index 3b853e2..68f34aa 100644
--- a/pgadmin/dlg/dlgSelectConnection.cpp
+++ b/pgadmin/dlg/dlgSelectConnection.cpp
@@ -105,7 +105,7 @@ void dlgSelectConnection::OnChangeServer(wxCommandEvent &ev)
 	int sel = cbServer->GetCurrentSelection();
 	if (sel >= 0)
 	{
-		remoteServer = (pgServer *)cbServer->GetClientData(sel);
+		remoteServer = (pgServer *)cbServer->wxItemContainer::GetClientData(sel);
 
 		if (!remoteServer->GetConnected())
 		{
diff --git a/pgadmin/frm/frmOptions.cpp b/pgadmin/frm/frmOptions.cpp
index 3902abe..92f9b75 100644
--- a/pgadmin/frm/frmOptions.cpp
+++ b/pgadmin/frm/frmOptions.cpp
@@ -122,6 +122,7 @@ END_EVENT_TABLE()
 //----------------------------------------------------------------------------
 
 #ifdef __WXMAC__
+#if !wxCHECK_VERSION(2, 9, 0)
 
 #include <wx/fontdlg.h>
 #include <wx/richtext/richtextbuffer.h>
@@ -201,6 +202,7 @@ int wxRichTextFontDialog::ShowModal()
 }
 
 #endif
+#endif
 
 //----------------------------------------------------------------------------
 
diff --git a/pgadmin/frm/frmStatus.cpp b/pgadmin/frm/frmStatus.cpp
index 8c9346e..d98174f 100644
--- a/pgadmin/frm/frmStatus.cpp
+++ b/pgadmin/frm/frmStatus.cpp
@@ -1745,7 +1745,7 @@ void frmStatus::OnRefreshLogTimer(wxTimerEvent &event)
 			while (newfiles--)
 			{
 				addLogLine(_("pgadmin:Logfile rotated."), false);
-				wxDateTime *ts = (wxDateTime *)cbLogfiles->GetClientData(pos++);
+				wxDateTime *ts = (wxDateTime *)cbLogfiles->wxItemContainer::GetClientData(pos++);
 				wxASSERT(ts != 0);
 
 				addLogFile(ts, skipFirst);
@@ -2316,7 +2316,7 @@ void frmStatus::emptyLogfileCombo()
 
 	while (cbLogfiles->GetCount())
 	{
-		wxDateTime *dt = (wxDateTime *)cbLogfiles->GetClientData(0);
+		wxDateTime *dt = (wxDateTime *)cbLogfiles->wxItemContainer::GetClientData(0);
 		if (dt)
 			delete dt;
 		cbLogfiles->Delete(0);
@@ -2374,7 +2374,7 @@ void frmStatus::OnLoadLogfile(wxCommandEvent &event)
 		showCurrent = (pos == 0);
 		isCurrent = showCurrent || (pos == lastPos);
 
-		wxDateTime *ts = (wxDateTime *)cbLogfiles->GetClientData(showCurrent ? lastPos : pos);
+		wxDateTime *ts = (wxDateTime *)cbLogfiles->wxItemContainer::GetClientData(showCurrent ? lastPos : pos);
 		wxASSERT(ts != 0);
 
 		if (ts != NULL && (!logfileTimestamp.IsValid() || *ts != logfileTimestamp))
diff --git a/pgadmin/slony/dlgRepCluster.cpp b/pgadmin/slony/dlgRepCluster.cpp
index b00c802..ee370c5 100644
--- a/pgadmin/slony/dlgRepCluster.cpp
+++ b/pgadmin/slony/dlgRepCluster.cpp
@@ -113,7 +113,7 @@ void dlgRepClusterBase::OnChangeServer(wxCommandEvent &ev)
 	int sel = cbServer->GetCurrentSelection();
 	if (sel >= 0)
 	{
-		remoteServer = (pgServer *)cbServer->GetClientData(sel);
+		remoteServer = (pgServer *)cbServer->wxItemContainer::GetClientData(sel);
 
 		if (!remoteServer->GetConnected())
 		{
@@ -773,7 +773,7 @@ void dlgRepCluster::OnOK(wxCommandEvent &ev)
 			done = remoteConn->ExecuteVoid(
 			           wxT("SELECT ") + schemaPrefix + wxT("storepath(") +
 			           txtNodeID->GetValue() + wxT(", ") +
-			           NumToStr((long)cbAdminNode->GetClientData(cbAdminNode->GetCurrentSelection())) + wxT(", ") +
+			           NumToStr((long)cbAdminNode->wxItemContainer::GetClientData(cbAdminNode->GetCurrentSelection())) + wxT(", ") +
 			           qtDbString(wxT("host=") + database->GetServer()->GetName() +
 			                      wxT(" port=") + NumToStr((long)database->GetServer()->GetPort()) +
 			                      wxT(" dbname=") + database->GetName()) + wxT(", ")
@@ -812,7 +812,7 @@ void dlgRepCluster::CheckChange()
 	if (cluster)
 	{
 		int sel = cbAdminNode->GetCurrentSelection();
-		bool changed = (sel >= 0 && (long)cbAdminNode->GetClientData() != cluster->GetAdminNodeID());
+		bool changed = (sel >= 0 && (long)cbAdminNode->wxEvtHandler::GetClientData() != cluster->GetAdminNodeID());
 
 		EnableOK(changed || txtComment->GetValue() != cluster->GetComment());
 	}
@@ -921,7 +921,7 @@ wxString dlgRepCluster::GetSql()
 		int sel = cbAdminNode->GetCurrentSelection();
 		if (sel >= 0)
 		{
-			long id = (long)cbAdminNode->GetClientData(sel);
+			long id = (long)cbAdminNode->wxItemContainer::GetClientData(sel);
 			if (id != cluster->GetAdminNodeID())
 				settings->WriteLong(wxT("Replication/") + cluster->GetName() + wxT("/AdminNode"), id);
 		}
diff --git a/pgadmin/slony/dlgRepListen.cpp b/pgadmin/slony/dlgRepListen.cpp
index 07c672d..5c2e48d 100644
--- a/pgadmin/slony/dlgRepListen.cpp
+++ b/pgadmin/slony/dlgRepListen.cpp
@@ -108,9 +108,9 @@ int dlgRepListen::Go(bool modal)
 pgObject *dlgRepListen::CreateObject(pgCollection *collection)
 {
 	pgObject *obj = listenFactory.CreateObjects(collection, 0,
-	                wxT(" WHERE li_origin = ") + NumToStr((OID)cbOrigin->GetClientData(cbOrigin->GetCurrentSelection())) +
+	                wxT(" WHERE li_origin = ") + NumToStr((OID)cbOrigin->wxItemContainer::GetClientData(cbOrigin->GetCurrentSelection())) +
 	                wxT("   AND li_receiver = ") + NumToStr(node->GetSlId()) +
-	                wxT("   AND li_provider = ") + NumToStr((OID)cbProvider->GetClientData(cbProvider->GetCurrentSelection()))
+	                wxT("   AND li_provider = ") + NumToStr((OID)cbProvider->wxItemContainer::GetClientData(cbProvider->GetCurrentSelection()))
 	                                           );
 
 	return obj;
@@ -150,8 +150,8 @@ wxString dlgRepListen::GetSql()
 		// create mode
 
 		sql = wxT("SELECT ") + cluster->GetSchemaPrefix() + wxT("storelisten(")
-		      + NumToStr((OID)cbOrigin->GetClientData(cbOrigin->GetCurrentSelection())) + wxT(", ")
-		      + NumToStr((OID)cbProvider->GetClientData(cbProvider->GetCurrentSelection())) + wxT(", ")
+		      + NumToStr((OID)cbOrigin->wxItemContainer::GetClientData(cbOrigin->GetCurrentSelection())) + wxT(", ")
+		      + NumToStr((OID)cbProvider->wxItemContainer::GetClientData(cbProvider->GetCurrentSelection())) + wxT(", ")
 		      + NumToStr(node->GetSlId()) + wxT(");");
 	}
 
diff --git a/pgadmin/slony/dlgRepPath.cpp b/pgadmin/slony/dlgRepPath.cpp
index 03298f1..5fb4f2f 100644
--- a/pgadmin/slony/dlgRepPath.cpp
+++ b/pgadmin/slony/dlgRepPath.cpp
@@ -103,7 +103,7 @@ int dlgRepPath::Go(bool modal)
 pgObject *dlgRepPath::CreateObject(pgCollection *collection)
 {
 	pgObject *obj = pathFactory.CreateObjects(collection, 0,
-	                wxT(" WHERE pa_server = ") + NumToStr((OID)cbServer->GetClientData(cbServer->GetCurrentSelection())) +
+	                wxT(" WHERE pa_server = ") + NumToStr((OID)cbServer->wxItemContainer::GetClientData(cbServer->GetCurrentSelection())) +
 	                wxT("   AND pa_client = ") + NumToStr(node->GetSlId()));
 
 	return obj;
@@ -145,7 +145,7 @@ wxString dlgRepPath::GetSql()
 	if (sel >= 0)
 	{
 		sql = wxT("SELECT ") + cluster->GetSchemaPrefix() + wxT("storepath(")
-		      + NumToStr((OID)cbServer->GetClientData(sel)) + wxT(", ")
+		      + NumToStr((OID)cbServer->wxItemContainer::GetClientData(sel)) + wxT(", ")
 		      + NumToStr(node->GetSlId()) + wxT(", ")
 		      + qtDbString(txtConnInfo->GetValue()) + wxT(", ")
 		      + NumToStr(StrToLong(txtConnRetry->GetValue())) + wxT(");");
diff --git a/pgadmin/slony/dlgRepSequence.cpp b/pgadmin/slony/dlgRepSequence.cpp
index 3798138..a948fa5 100644
--- a/pgadmin/slony/dlgRepSequence.cpp
+++ b/pgadmin/slony/dlgRepSequence.cpp
@@ -107,7 +107,7 @@ int dlgRepSequence::Go(bool modal)
 pgObject *dlgRepSequence::CreateObject(pgCollection *collection)
 {
 	pgObject *obj = slSequenceFactory.CreateObjects(collection, 0,
-	                wxT(" WHERE seq_reloid = ") + NumToStr((OID)cbSequence->GetClientData(cbSequence->GetGuessedSelection())));
+	                wxT(" WHERE seq_reloid = ") + NumToStr((OID)cbSequence->wxItemContainer::GetClientData(cbSequence->GetGuessedSelection())));
 
 	return obj;
 }
diff --git a/pgadmin/slony/dlgRepSet.cpp b/pgadmin/slony/dlgRepSet.cpp
index f44adb2..385c4b0 100644
--- a/pgadmin/slony/dlgRepSet.cpp
+++ b/pgadmin/slony/dlgRepSet.cpp
@@ -188,7 +188,7 @@ wxString dlgRepSetMerge::GetSql()
 {
 	wxString sql;
 	wxString addId = NumToStr(set->GetSlId());
-	wxString toId = NumToStr((long)cbTargetID->GetClientData(cbTargetID->GetCurrentSelection()));
+	wxString toId = NumToStr((long)cbTargetID->wxItemContainer::GetClientData(cbTargetID->GetCurrentSelection()));
 	wxString prefix = cluster->GetSchemaPrefix();
 
 	if (set->GetSubscriptionCount() > 0)
@@ -323,7 +323,7 @@ void dlgRepSetMove::CheckChange()
 
 wxString dlgRepSetMove::GetSql()
 {
-	wxString toId = NumToStr((long)cbTargetNode->GetClientData(cbTargetNode->GetCurrentSelection()));
+	wxString toId = NumToStr((long)cbTargetNode->wxItemContainer::GetClientData(cbTargetNode->GetCurrentSelection()));
 
 	wxString sql =
 	    wxT("SELECT ") + cluster->GetSchemaPrefix() + wxT("moveset(") +
diff --git a/pgadmin/slony/dlgRepSubscription.cpp b/pgadmin/slony/dlgRepSubscription.cpp
index 67be42c..29e9def 100644
--- a/pgadmin/slony/dlgRepSubscription.cpp
+++ b/pgadmin/slony/dlgRepSubscription.cpp
@@ -136,7 +136,7 @@ void dlgRepSubscription::CheckChange()
 		int sel = cbProvider->GetCurrentSelection();
 
 		EnableOK(sel >= 0 && (chkForward->GetValue() != subscription->GetForward()
-		                      ||   (long)cbProvider->GetClientData(sel) != subscription->GetProviderId()));
+		                      ||   (long)cbProvider->wxItemContainer::GetClientData(sel) != subscription->GetProviderId()));
 	}
 	else
 	{
@@ -159,11 +159,11 @@ wxString dlgRepSubscription::GetSql()
 	{
 		// Actually, provider and receiver are exchanged here.
 		sql += NumToStr(cluster->GetLocalNodeID()) + wxT(", ")
-		       + NumToStr((long)cbProvider->GetClientData(cbProvider->GetCurrentSelection()));
+		       + NumToStr((long)cbProvider->wxItemContainer::GetClientData(cbProvider->GetCurrentSelection()));
 	}
 	else
 	{
-		sql += NumToStr((long)cbProvider->GetClientData(cbProvider->GetCurrentSelection())) + wxT(", ")
+		sql += NumToStr((long)cbProvider->wxItemContainer::GetClientData(cbProvider->GetCurrentSelection())) + wxT(", ")
 		       + NumToStr(cluster->GetLocalNodeID());
 	}
 	sql += wxT(", ")
diff --git a/pgadmin/slony/dlgRepTable.cpp b/pgadmin/slony/dlgRepTable.cpp
index c7368e5..22ee375 100644
--- a/pgadmin/slony/dlgRepTable.cpp
+++ b/pgadmin/slony/dlgRepTable.cpp
@@ -124,7 +124,7 @@ int dlgRepTable::Go(bool modal)
 pgObject *dlgRepTable::CreateObject(pgCollection *collection)
 {
 	pgObject *obj = slTableFactory.CreateObjects(collection, 0,
-	                wxT(" WHERE tab_reloid = ") + NumToStr((OID)cbTable->GetClientData(cbTable->GetGuessedSelection())));
+	                wxT(" WHERE tab_reloid = ") + NumToStr((OID)cbTable->wxItemContainer::GetClientData(cbTable->GetGuessedSelection())));
 
 	return obj;
 }
@@ -147,7 +147,7 @@ void dlgRepTable::OnChangeTable(wxCommandEvent &ev)
 
 	if (sel >= 0)
 	{
-		OID relid = (OID)cbTable->GetClientData(sel);
+		OID relid = (OID)cbTable->wxItemContainer::GetClientData(sel);
 
 		pgSet *idx = connection->ExecuteSet(
 		                 wxT("SELECT relname\n")