diff --git a/docs/en_US/appendices.rst b/docs/en_US/appendices.rst
index d64e342..686b13e 100644
--- a/docs/en_US/appendices.rst
+++ b/docs/en_US/appendices.rst
@@ -14,6 +14,6 @@ Contents:
 
 pgAdmin includes software from the OpenSSL and MIT Kerberos projects:
 
-* `MIT Kerberos licence <kerberos.html>`_
-* `The OpenSSL licence <openssl.html>`_
+* `MIT Kerberos licence <kerberos>`_
+* `The OpenSSL licence <openssl>`_
 
diff --git a/docs/en_US/connect.rst b/docs/en_US/connect.rst
index 9082715..3f3d166 100644
--- a/docs/en_US/connect.rst
+++ b/docs/en_US/connect.rst
@@ -10,7 +10,7 @@ Connect to server
 Use this dialog to add a new server connection to the pgAdmin tree.
 
 If you're experiencing connection problems, check the `connection problems
-<connect-error.html>`_.
+<connect-error>`_.
 
 The name is a text to identify the server in the pgAdmin tree.
 
@@ -26,8 +26,8 @@ pg_service.conf file. For details, see the `pg_service
 documentation <http://www.postgresql.org/docs/9.0/interactive/libpq-pgservice.html>`_.
 
 The maintenance DB field is used to specify the initial database that 
-pgAdmin connects to, and that will be expected to have the `pgAgent <pgagent.html>`_
-schema and `adminpack <extend.html>`_ objects 
+pgAdmin connects to, and that will be expected to have the `pgAgent <pgagent>`_
+schema and `adminpack <extend>`_ objects
 installed (both optional). On PostgreSQL 8.1 and above, the maintenance
 DB is normally called 'postgres', and on earlier versions 'template1' is
 often used, though it is preferrable to create a 'postgres' database for 
diff --git a/docs/en_US/extend.rst b/docs/en_US/extend.rst
new file mode 100644
index 0000000..91885d9
--- /dev/null
+++ b/docs/en_US/extend.rst
@@ -0,0 +1,53 @@
+.. _extend:
+
+
+*****************
+Extended features
+*****************
+
+pgAdmin III's functionality can be further enhanced using the *adminpack* contrib
+module for PostgreSQL. This is a library of additional functions that may be installed 
+on your server which allows pgAdmin to offer additional features, such as:
+
+* The sizes on disk of tablespaces, databases, tables and indexes are
+  displayed on the Statistics tab in the :ref:`main window <main>`.
+
+* The :ref:`Status dialogue <status>` should be able to display the
+  server logfiles (if logging is appropriately configured).
+
+* Running queries from other users may be cancelled from the 
+  :ref:`Status dialogue <status>`.
+
+* The server's configuration files postgresql.conf and pg_hba.conf
+  may be editted, and reloaded remotely.
+
+The adminpack is installed and activated by default if you are running the 
+'official' pgInstaller distribution of PostgreSQL for Windows and is included as a
+contrib module with all versions of PostgreSQL 8.2 and above. However, if you are 
+running any other version of PostgreSQL you will need to manually install it. To do so,
+simply copy the appropriate adminpack source code to the /contrib directory of your
+pre-configured PostgreSQL source tree. You can download the adminpacks
+`here <http://www.pgadmin.org/download/adminpacks.php>`_.
+
+Run the following commands (substituting *admin* for *admin81* 
+if required)::
+
+  # cd $PGSRC/contrib/admin
+  # make all
+  # make install
+
+The module should now be built, and installed into your existing PostgreSQL installation.
+To be used, you must now install the module into the database you use as pgAdmin's *Maintenance
+DB* (normally *postgres*, though you may wish to use a different database). To do so, 
+locate the *admin.sql* or *admin81.sql* file installed in the previous step - normally 
+this may be found in /usr/local/pgsql/share/contrib/ and run it against your database. You will 
+normally need to do this as the PostgreSQL superuser::
+
+  $ psql postgres < /usr/local/pgsql/share/contrib/admin.sql
+
+The next time you connect to the server with pgAdmin, it will detect the presence of the adminpack
+and offer full functionality.
+
+Since PostgreSQL 9.1, you don't need to use psql. You can manually add
+adminpack extension or make pgAdmin do the same by clicking on the "Fix It!"
+button of the guru hint.
diff --git a/docs/en_US/extended.rst b/docs/en_US/extended.rst
deleted file mode 100644
index 91885d9..0000000
--- a/docs/en_US/extended.rst
+++ /dev/null
@@ -1,53 +0,0 @@
-.. _extend:
-
-
-*****************
-Extended features
-*****************
-
-pgAdmin III's functionality can be further enhanced using the *adminpack* contrib
-module for PostgreSQL. This is a library of additional functions that may be installed 
-on your server which allows pgAdmin to offer additional features, such as:
-
-* The sizes on disk of tablespaces, databases, tables and indexes are
-  displayed on the Statistics tab in the :ref:`main window <main>`.
-
-* The :ref:`Status dialogue <status>` should be able to display the
-  server logfiles (if logging is appropriately configured).
-
-* Running queries from other users may be cancelled from the 
-  :ref:`Status dialogue <status>`.
-
-* The server's configuration files postgresql.conf and pg_hba.conf
-  may be editted, and reloaded remotely.
-
-The adminpack is installed and activated by default if you are running the 
-'official' pgInstaller distribution of PostgreSQL for Windows and is included as a
-contrib module with all versions of PostgreSQL 8.2 and above. However, if you are 
-running any other version of PostgreSQL you will need to manually install it. To do so,
-simply copy the appropriate adminpack source code to the /contrib directory of your
-pre-configured PostgreSQL source tree. You can download the adminpacks
-`here <http://www.pgadmin.org/download/adminpacks.php>`_.
-
-Run the following commands (substituting *admin* for *admin81* 
-if required)::
-
-  # cd $PGSRC/contrib/admin
-  # make all
-  # make install
-
-The module should now be built, and installed into your existing PostgreSQL installation.
-To be used, you must now install the module into the database you use as pgAdmin's *Maintenance
-DB* (normally *postgres*, though you may wish to use a different database). To do so, 
-locate the *admin.sql* or *admin81.sql* file installed in the previous step - normally 
-this may be found in /usr/local/pgsql/share/contrib/ and run it against your database. You will 
-normally need to do this as the PostgreSQL superuser::
-
-  $ psql postgres < /usr/local/pgsql/share/contrib/admin.sql
-
-The next time you connect to the server with pgAdmin, it will detect the presence of the adminpack
-and offer full functionality.
-
-Since PostgreSQL 9.1, you don't need to use psql. You can manually add
-adminpack extension or make pgAdmin do the same by clicking on the "Fix It!"
-button of the guru hint.
diff --git a/docs/en_US/index.rst b/docs/en_US/index.rst
index ba57af3..1efc212 100644
--- a/docs/en_US/index.rst
+++ b/docs/en_US/index.rst
@@ -10,6 +10,6 @@ Contents:
    using
    pgagent.rst
    slony.rst
-   extended.rst
+   extend.rst
    appendices.rst
 
diff --git a/docs/en_US/main.rst b/docs/en_US/main.rst
index a422d1e..b5083ab 100644
--- a/docs/en_US/main.rst
+++ b/docs/en_US/main.rst
@@ -23,8 +23,8 @@ tab.
 The lower right side contains a reverse engineered SQL script. You
 can copy this to any editor using cut & paste, or save it to a file
 using Save definition... from the File menu, or use it as a template
-if you select the `Query Tool <query.html>`_. If the
-`Copy SQL from main window to query tool <options-tab4.html>`_ option is selected, the SQL
+if you select the `Query Tool <query>`_. If the
+`Copy SQL from main window to query tool <options-tab4>`_ option is selected, the SQL
 query will be copied automatically to the tool.
 
 The status line will show you some status information, as well as
diff --git a/docs/en_US/options-tab1.rst b/docs/en_US/options-tab1.rst
index f56ba2f..d706186 100644
--- a/docs/en_US/options-tab1.rst
+++ b/docs/en_US/options-tab1.rst
@@ -57,6 +57,6 @@ pgAdmin Options - Tab 1 (General)
    Greenplum.
 
 * **Ignore server/utility version mismatches** - When checked, pgAdmin will pass the '-i' option 
-   to utilities such as <i>pg_dump</i> which will allow utilities from one version of the database to 
+   to utilities such as *pg_dump* which will allow utilities from one version of the database to
    be used with another version. This option should be use with extreme care as it may cause errors to
    occur during backup or restore options.
diff --git a/docs/en_US/reports.rst b/docs/en_US/reports.rst
index 849a78a..bb56d20 100644
--- a/docs/en_US/reports.rst
+++ b/docs/en_US/reports.rst
@@ -46,7 +46,7 @@ XML linked to an external XSL stylesheet, or to process the XML using an
 external stylesheet and save the resulting output. This allows complete 
 flexibility to format reports in any way.
 
-The default `XSL stylesheet <default-xsl.html>`_ used to render 
+The default `XSL stylesheet <default-xsl>`_ used to render 
 XHTML output can be used as a starting point for your own, and sample 
-`XML data <sample-xml.html>`_ may also be reviewed if required.
+`XML data <sample-xml>`_ may also be reviewed if required.
 
diff --git a/docs/en_US/slony-functions.rst b/docs/en_US/slony-functions.rst
index 3164ba4..75ef472 100644
--- a/docs/en_US/slony-functions.rst
+++ b/docs/en_US/slony-functions.rst
@@ -1,5 +1,3 @@
-<html>
-
 .. _slony-functions:
 
 
diff --git a/docs/en_US/slony-path.rst b/docs/en_US/slony-path.rst
index fe51f5f..a6f0177 100644
--- a/docs/en_US/slony-path.rst
+++ b/docs/en_US/slony-path.rst
@@ -34,6 +34,3 @@ to be advised to listen to events from other nodes.
 
 **Note:** This step is not necessary for Slony-I v1.1 and later, because
 listen information is generated automatically when paths are defined.
-</p>
-</body>
-</html>